{{
Wii MotionPlus Driver Demo Object v1.0
By Pat Daderko (DogP)

Based on a Wii nunchuck example project from John Abshier, which was based on code originally by Joo Geada

This demo object repeatedly polls the Wii MotionPlus and writes the gyro data to the serial port (at 115200bps),
reusing the pins used for programming.

Diagram below is showing the pinout looking into the connector on the top (which plugs into the Wii Remote)
 _______ 
| 1 2 3 |
|       |
| 6 5 4 |
|_-----_|

1 - SDA 
2 - 
3 - VCC
4 - SCL 
5 - 
6 - GND

This is an I2C peripheral, and requires a pullup resistor on the SDA line
If using a prop board with an I2C EEPROM, this can be connected directly to pin 28 (SCL) and pin 29 (SDA)
}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  MP : "MotionPlus"
  Nun : "Nunchuck"
  tv   : "tv_text"
PUB init
   tv.start(12)               ' start TV display  base pin 12
   MP.init(28,29) 'initialize I2C MotionPlus on existing I2C pins
   Nun.init(28,29) 'initialize I2C Nunchuck on existing I2C pins
   MP.enMotionPlus 'enable MotionPlus (write enable sequence to hardware)
   mainLoop 'run main app

PUB mainLoop
  repeat
  
  
    
     MP.enMotionPlus 'enable MotionPlus (write enable sequence to hardware)

      MP.readMotionPlus 'read data from MotionPlus
                  
      tv.str(string($a,1,$b,7))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,7))      '
      tv.str(string("Gyro-X  "))      '
      tv.str(string($a,8,$b,7))      '
      tv.dec(MP.rotate_x)  
      tv.str(string($a,1,$b,8))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,8))      '
      tv.str(string("Gyro-Y  "))      '
      tv.str(string($a,8,$b,8))      '
      tv.dec(MP.rotate_y)
      tv.str(string($a,1,$b,9))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,9))      '
      tv.str(string("Gyro-Z  "))      '
      tv.str(string($a,8,$b,9))      '
      tv.dec(MP.rotate_z)        

     MP.disableMotionPlus 'disable MotionPlus (write disable sequence to hardware)

    waitcnt(clkfreq/64 + cnt) 'wait for a short period

   Nun.readNunchuck 'read data from Nunchuck
      
      tv.str(string($a,1,$b,1))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,1))      '
      tv.str(string("Accel-X"))      '
      tv.str(string($a,9,$b,1))      '
      tv.dec(Nun.accelX)
      tv.str(string($a,1,$b,2))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,2))      '
      tv.str(string("Accel-Y"))      '
      tv.str(string($a,9,$b,2))      '
      tv.dec(Nun.accelY)
      tv.str(string($a,1,$b,3))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,3))      '
      tv.str(string("Accel-Z"))      '
      tv.str(string($a,9,$b,3))      '
      tv.dec(Nun.accelZ)
      tv.str(string($a,1,$b,4))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,4))      '
      tv.str(string("Pitch"))      '
      tv.str(string($a,9,$b,4))      '
      tv.dec(Nun.pitch)
      tv.str(string($a,1,$b,5))      '
      tv.str(string("             "))      '
      tv.str(string($a,1,$b,5))      '
      tv.str(string("Roll"))      '
      tv.str(string($a,9,$b,5))      '
      tv.dec(Nun.roll)
   
      
          waitcnt(clkfreq/64 + cnt) 'wait for a short period
   